; IDL DISLIN wrapper shortcut procedure to draw a rectangle
; Version 1.6, 31.03.2017, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_box, x, y, diameter_x, diameter_y, color=color, line=line, width=width, filled=filled, pattern=pattern

	num = n_elements (x)
	if (num ne n_elements (y)) then message, 'ERROR: unequal number of x- and y-coordinates!'

	if (size (color, /type) eq 0) then color = 'black'
	if (n_elements (color) eq 1) then color = replicate (color, num)
	if (size (diameter_x, /type) eq 0) then diameter_x = 1
	if ((n_elements (diameter_x) eq 1) and (num gt 1)) then diameter_x = replicate (diameter_x, num)
	if (size (diameter_y, /type) eq 0) then diameter_y = 1
	if ((n_elements (diameter_y) eq 1) and (num gt 1)) then diameter_y = replicate (diameter_y, num)
	if (size (filled, /type) eq 0) then filled = 0
	if ((n_elements (filled) eq 1) and (num gt 1)) then filled = replicate (filled, num)
	if (size (pattern, /type) eq 0) then if (keyword_set (filled)) then pattern = 16 else pattern = 0
	if ((n_elements (pattern) eq 1) and (num gt 1)) then pattern = replicate (pattern, num)

	if (size (width, /type) ne 0) then dislin, 'linwid', round (width)
	if (n_elements (line) eq 1) then begin
		if (size (line, /type) ne 7) then line = 'solid'
		dislin, line
	end else if (n_elements (line) ge 2) then begin
		dislin, 'myline', round (line), n_elements (line)
	end

	for pos = 0, num-1 do begin
		dislin_color, color, pick=pos
		if (keyword_set (filled[pos])) then dislin, 'shdpat', round (pattern[pos])
		dislin, 'rlrec', double (x[pos]-0.5*diameter_x[pos]), double (y[pos]+0.5*diameter_y[pos]), double (diameter_x[pos]), double (diameter_y[pos])
	end
end

