; IDL DISLIN wrapper shortcut procedure to draw a circle
; Version 1.6, 31.03.2017, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_circle, x, y, radius, color=color, line=line, width=width, filled=filled, pattern=pattern, angle=angle

	num = n_elements (x)
	if (num ne n_elements (y)) then message, 'ERROR: unequal number of x- and y-coordinates!'

	if (size (color, /type) eq 0) then color = 'black'
	if (n_elements (color) eq 1) then color = replicate (color, num)
	if (size (radius, /type) eq 0) then radius = 1
	if (n_elements (radius) eq 1) then radius = replicate (radius, num)
	if (size (filled, /type) eq 0) then filled = 0
	if (n_elements (filled) eq 1) then filled = replicate (filled, num)
	if (size (pattern, /type) eq 0) then if (keyword_set (filled)) then pattern = 16 else pattern = 0
	if (n_elements (pattern) eq 1) then pattern = replicate (pattern, num)

	if (keyword_set (angle)) then dislin, 'circsp', round (angle)
	if (size (width, /type) ne 0) then dislin, 'linwid', round (width)
	if (n_elements (line) eq 1) then begin
		if (size (line, /type) ne 7) then line = 'solid'
		dislin, line
	end else if (n_elements (line) ge 2) then begin
		dislin, 'myline', round (line), n_elements (line)
	end

	for pos = 0, num-1 do begin
		dislin_color, color, pick=pos
		if (keyword_set (filled[pos])) then dislin, 'shdpat', round (pattern[pos])
		dislin, 'rlcirc', double (x[pos]), double (y[pos]), double (radius[pos])
	end
end

