; IDL DISLIN wrapper shortcut function to set a color
; Version 1.6, 29.10.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_color, data, table=table, brightness=brightness, pick=pick, get_index=get_index, return=index

	if (size (data, /type) eq 0) then color = 1 else color = data
	if (n_elements (brightness) eq 0) then brightness = 1.0

	if (size (table, /type) ne 0) then begin
		data = dislin_colors (table=table, brightness=brightness)
		if (size (data, /type) eq 7) then begin
			dislin, 'setvlt', data
		end else begin
			dislin, 'myvlt', reform (data[*,0]), reform (data[*,1]), reform (data[*,2]), n_elements (data[*,0])
		end
		return
	end

	if (size (pick, /type) ne 0) then begin
		if (size (color, /n_dimensions) eq 2) then begin
			if (n_elements (color[0,*]) le pick) then return
			dislin_color, color[*,pick], brightness=brightness
		end else begin
			if (n_elements (color) le pick) then return
			dislin_color, color[pick], brightness=brightness
		end
		return
	end

	if (size (color, /type) eq 7) then begin
		if (strcmp ('fore', color, /fold_case)) then color = 1
		if (strcmp ('back', color, /fold_case)) then color = 0
	end

	if (size (color, /type) eq 7) then begin
		colors = dislin_colors (brightness=brightness)
		if (total (strcmp (tag_names (colors), color, /fold_case), /preserve_type) eq 0) then begin
			dislin, 'color', color
			return
		end
		result = execute ("color = colors."+color)
	end

	if (keyword_set (get_index) and ((n_elements (color) eq 1) or (n_elements (color) eq 3))) then begin
		if (n_elements (color) eq 1) then color = replicate (color, 3)
		dislin, 'intrgb', double (color[0]), double (color[1]), double (color[2]), return=index
		return
	end

	if ((size (color, /type) eq 4) or (size (color, /type) eq 5)) then begin
		if (n_elements (color) eq 1) then color = replicate (color, 3)
		if (n_elements (color) eq 3) then begin
			dislin, 'setrgb', color[0], color[1], color[2]
			return
		end
	end

	if (size (color, /type) ne 7) then begin
		if (color ge 2) then begin
			dislin, 'setclr', color
			return
		end
		if (keyword_set (color)) then color = 'fore' else color = 'back'
	end
	dislin, 'color', color

end

