; IDL DISLIN wrapper shortcut function to return a colors structure
; Version 1.5, 17.03.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

function dislin_colors, color, brightness=brightness, table=table, red=red, full_red=full_red, dark_red=dark_red, light_red=light_red, magenta=magenta, green=green, full_green=full_green, dark_green=dark_green, turquoise=turquoise, full_turquoise=full_turquoise, dark_turquoise=dark_turquoise, light_turquoise=light_turquoise, blue=blue, full_blue=full_blue, dark_blue=dark_blue, rose=rose, full_yellow=full_yellow, yellow=yellow, orange=orange, dark_orange=dark_orange, brown=brown, light_brown=light_brown, white=white, light_gray=light_gray, gray=gray, dark_gray=dark_gray, light_grey=light_grey, grey=grey, dark_grey=dark_grey, black=black

	if (size (brightness, /type) eq 0) then brightness = 1.0

	if (size (table, /type) ne 0) then begin
		if (size (table, /type) ne 7) then begin
			case (table) of
				-1:	return, "rgrey"
				1:	return, "rain"
				2:	return, "rrain"
				else:	return, "grey"
			end
		end
		default_color_tables = [ "grey" , "rgrey" , "spec", "rspec", "rain", "rrain", "temp", "vga", "small" ]
		if (max (strcmp (table, default_color_tables, /fold_case))) then return, table
		if (strcmp (table, "rgray", /fold_case)) then return, "rgrey"
		if (strcmp (table, "gray", /fold_case)) then return, "grey"
		if (strcmp (table, "blue_red", /fold_case)) then return, reverse (dislin_colors (table="red_blue"))
		if (strcmp (table, "red_blue", /fold_case)) then begin
			N_colors = 256
			low = 1
			high = N_colors - 1
			center = byte ((low + (high-1)) / 2.0)
			r = bytarr (N_colors)
			g = bytarr (N_colors)
			b = bytarr (N_colors)
			inc = bytscl (findgen (center-low+1)+1)
			dec = reverse (bytscl (findgen ((high-1)-center+1)+1))
			r[low:center] = high  &  r[center:high-1] = dec
			g[low:center] = inc   &  g[center:high-1] = dec
			b[low:center] = inc   &  b[center:high-1] = high
			color_table = [ [r], [g], [b] ] * brightness / high
			color_table[high,*] = 0
			return, color_table
		end
		return, default_color_tables[0]
	end

	red             = [ 0.8, 0.0, 0.0 ] * brightness
	full_red        = [ 1.0, 0.0, 0.0 ] * brightness
	dark_red        = [ 0.5, 0.0, 0.0 ] * brightness
	light_red       = [ 1.0, 0.5, 0.5 ] * brightness
	magenta         = [ 1.0, 0.0, 0.5625 ] * brightness
	green           = [ 0.0, 0.6, 0.0 ] * brightness
	full_green      = [ 0.0, 1.0, 0.0 ] * brightness
	dark_green      = [ 0.0, 0.5, 0.0 ] * brightness
	light_green     = [ 0.5, 1.0, 0.5 ] * brightness
	turquoise       = [ 0.0, 0.8, 0.8 ] * brightness
	full_turquoise  = [ 0.0, 1.0, 1.0 ] * brightness
	dark_turquoise  = [ 0.0, 0.6, 0.6 ] * brightness
	light_turquoise = [ 0.5, 1.0, 1.0 ] * brightness
	blue            = [ 0.2, 0.2, 1.0 ] * brightness
	full_blue       = [ 0.0, 0.0, 1.0 ] * brightness
	dark_blue       = [ 0.0, 0.0, 0.5 ] * brightness
	light_blue      = [ 0.5, 0.5, 1.0 ] * brightness
	rose            = [ 1.0, 0.5, 1.0 ] * brightness
	full_yellow     = [ 1.0, 1.0, 0.0 ] * brightness
	yellow          = [ 1.0, 0.875, 0.0 ] * brightness
	orange          = [ 0.9, 0.6, 0.0 ] * brightness
	dark_orange     = [ 0.8, 0.5, 0.0 ] * brightness
	light_orange    = [ 1.0, 0.8, 0.5 ] * brightness
	brown           = [ 0.6, 0.2, 0.0 ] * brightness
	light_brown     = [ 0.75, 0.375, 0.0 ] * brightness
	white           = [ 1.0, 1.0, 1.0 ] * brightness
	light_gray      = [ 0.75, 0.75, 0.75 ] * brightness
	gray            = [ 0.5, 0.5, 0.5 ] * brightness
	dark_gray       = [ 0.25, 0.25, 0.25 ] * brightness
	light_grey      = light_gray
	grey            = gray
	dark_grey       = dark_gray
	black           = [ 0.0, 0.0, 0.0 ] * brightness

	if (size (color, /type) ne 0) then dislin_color, color

	return, { red:red, full_red:full_red, dark_red:dark_red, light_red:light_red, magenta:magenta, green:green, full_green:full_green, dark_green:dark_green, light_green:light_green, turquoise:turquoise, full_turquoise:full_turquoise, dark_turquoise:dark_turquoise, light_turquoise:light_turquoise, blue:blue, full_blue:full_blue, dark_blue:dark_blue, light_blue:light_blue, rose:rose, full_yellow:full_yellow, yellow:yellow, orange:orange, dark_orange:dark_orange, light_orange:light_orange, brown:brown, light_brown:light_brown, white:white, light_gray:light_gray, gray:gray, dark_gray:dark_gray, light_grey:light_grey, grey:grey, dark_grey:dark_grey, black:black }
end

