; IDL DISLIN wrapper shortcut procedure to create a new graf plot
; Version 1.8, 05.10.2018, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_graf, x, y, z, type=type, polar=polar, map=map, grid_lines=grid_lines, grid_type=grid_type, grid_color=grid_color, view_point=view_point, view_type=view_type, box=box, exact=exact, integer=integer, log=log, label_log=label_log, labeling=labeling, clip=clip, ticks=ticks, tick_pos=tick_pos, tick_len=tick_len, color_table=color_table, num_colors=num_colors, resolution=resolution, projection=projection, background=background, draw_frame=draw_frame, frame_color=frame_color, axis_color=axis_color, frame_width=frame_width, light_mode=light_mode, xs=xs, xe=xe, xf=xf, xd=xd, xn=xn, ys=ys, ye=ye, yf=yf, yd=yd, yn=yn, zs=zs, ze=ze, zf=zf, zd=zd, zn=zn, es=es, ee=ee, ef=ef, ed=ed, en=en, min_s=min_s, max_s=max_s, min_e=min_e, max_e=max_e, min_f=min_f, max_f=max_f, min_d=min_d, max_d=max_d, min_n=min_n, max_n=max_n

	common dislin_axis_config, default_type, default_label_type, default_label_axis, default_offset, default_target
	common dislin_skip_config, dislin_skip_page

	if (keyword_set (dislin_skip_page)) then return

	NaN = !Values.D_NaN

	if (size (exact, /type) ne 7) then if (keyword_set (exact)) then exact = 'xyz' else exact = ''
	extend = [ "extend", "extend", "extend" ]
	if (strpos (exact, 'x') ge 0) then extend[0] = "noextend"
	if (strpos (exact, 'y') ge 0) then extend[1] = "noextend"
	if (strpos (exact, 'z') ge 0) then extend[2] = "noextend"
	if (size (type, /type) eq 0) then type = default_type
	if ((size (type, /type) ne 7) and keyword_set (type)) then type = '3D'
	if (size (type, /type) ne 7) then type = ''
	draw_frame = keyword_set (draw_frame) or (size (frame_color, /type) ne 0) or (size (frame_width, /type) ne 0)
	if (n_elements (resolution) eq 1) then resolution = [ resolution, resolution ]
	if (keyword_set (projection)) then begin
		if (n_elements (projection) eq 9) then begin
			vector = double (projection)
			dislin, 'grfini', vector[0], vector[1], vector[2], vector[3], vector[4], vector[5], vector[6], vector[7], vector[8]
		end else if (strcmp (projection, 'end', /fold_case)) then begin
			if (size (frame_color, /type) ne 0) then dislin, 'frmclr', round (frame_color)
			if (size (frame_width, /type) ne 0) then dislin, 'frame', round (frame_width)
			if (draw_frame) then dislin, 'box2d'
			dislin, 'grffin'
			return
		end
	end
	if (not keyword_set (clip)) then clip = "page"
	if (size (clip, /type) ne 7) then clip = "axis"
	if (not keyword_set (log)) then log = ''
	if (size (log, /type) ne 7) then log = 'xy'
	if (log eq '') then dislin, 'axsscl', "lin", "xyz" else dislin, 'axsscl', "log", log
	if ((size (label_log, /type) eq 0) or (keyword_set (label_log) and (size (label_log, /type) ne 7))) then label_log = log
	if (size (label_log, /type) ne 7) then label_log = ''
	if (label_log ne '') then dislin, 'labels', "log", label_log
	if (size (tick_pos, /type) ne 0) then begin
		if (n_elements (tick_pos) eq 1) then tick_pos = replicate (tick_pos, 3)
		if (n_elements (tick_pos) eq 2) then tick_pos = [ tick_pos, '' ]
		axis_str = [ "x", "y", "z" ]
		for axis = 0, 2 do begin
			pos = tick_pos[axis]
			if (size (pos, /type) ne 7) then begin
				if (keyword_set (pos)) then pos = "inside" else pos = "outside"
			end
			if (strlowcase (strmid (pos, 0, 3)) eq "out") then pos = "labels"
			if (strlowcase (strmid (pos, 0, 2)) eq "in") then pos = "revers"
			if (pos ne "") then dislin, 'ticpos', pos, axis_str[axis]
		end
	end
	if (size (tick_len, /type) ne 0) then begin
		if (n_elements (tick_len) eq 1) then tick_len = [ tick_len, tick_len ]
		dislin, 'ticlen', round (tick_len[0]), round (tick_len[1])
	end
	if ((size (grid_lines, /type) eq 0) and (keyword_set (grid_type) or keyword_set (grid_color))) then grid_lines = 1
	if (keyword_set (grid_lines)) then begin
		if (size (grid_type, /type) ne 7) then grid_type = 'all'
		if (n_elements (grid_lines) eq 1) then grid_lines = replicate (grid_lines, 2)
	end
	if (size (labeling, /type) ne 0) then begin
		if ((size (labeling, /type) ne 7) and (keyword_set (labeling))) then labeling = [ "name", "name", "ticks", "ticks" ]
		if (n_elements (labeling) eq 1) then labeling = replicate (labeling, 4)
		dislin, 'setgrf', labeling[0], labeling[1], labeling[2], labeling[3]
		if (total (strcmp (labeling, 'none', /fold_case)) eq 4) then dislin, 'nograf'
	end

	if (((size (x, /n_dimensions) ge 2) or (size (x, /type) eq 0)) and (size (y, /type) eq 0) and (size (z, /type) eq 0)) then begin
		if (size (x, /type) eq 0) then begin
			if (size (box, /type) eq 0) then message, "DISLIN graf: Please give the dimensions of the plot area."
			x = box
		end
		if (size (y, /type) eq 0) then y = reform (x[1,*])
		if ((size (x, /n_dimensions) ge 3) and (size (z, /type) eq 0)) then z = reform (x[2,*])
		x = reform (x[0,*])
	end

	if (keyword_set (polar)) then begin
		if (size (x, /type) eq 0) then x = 1.0
		if (n_elements (x) eq 1) then x = [ 0.0, x ]
		if (size (y, /type) eq 0) then y = 360.0
		if (n_elements (y) eq 1) then y = [ 0.0, y ]
		if (size (es, /type) eq 0) then es = NaN
		if (n_elements (es) eq 1) then es = [ es, NaN ]
		if (size (ee, /type) eq 0) then ee = NaN
		if (n_elements (ee) eq 1) then ee = [ ee, NaN ]
		es[1] = 0.0
		ee[1] = 360.0
	end

	if (strpos (log, 'x') ge 0) then x_pos = alog10 (x) else x_pos = double (x)
	if (size (es, /type) ne 0) then begin min_s = es & max_s = es & end
	if (size (ee, /type) ne 0) then begin min_e = ee & max_e = ee & end
	if (size (ef, /type) ne 0) then begin min_f = ef & max_f = ef & end
	if (size (ed, /type) ne 0) then begin min_d = ed & max_d = ed & end
	if (size (en, /type) ne 0) then begin min_n = en & max_n = en & end

	if (keyword_set (color_table)) then dislin_color, table=color_table
	back_type = size (background, /type)
	if (back_type ne 0) then begin
		num_back = n_elements (background)
		is_rgb = ((back_type eq 4) or (back_type eq 5)) and ((num_back eq 1) or (num_back eq 3))
		if ((back_type eq 7) and is_rgb) then begin
			if (total (background lt 0.0) + total (background gt 1.0) ne 0) then is_rgb = 0
		end
		if ((back_type eq 7) or is_rgb) then begin
			dislin_color, background, /get_index, return=index
		end else if (num_back eq 1) then begin
			index = background
		end
		if (size (index, /type) ne 0) then dislin, 'axsbgd', round (index)
	end
	if (size (axis_color, /type) ne 0) then dislin_color, axis_color

	if (n_elements (ticks) ge 1) then if (finite (ticks[0])) then dislin, 'ticks', round (ticks[0]), "x"
	if (keyword_set (integer)) then begin
		dislin, 'intax'
		if (size (xn, /type) eq 0) then xn = -1
		if (size (yn, /type) eq 0) then yn = -1
		if (size (zn, /type) eq 0) then zn = -1
	end
	if (keyword_set (map)) then begin
		if (size (min_f, /type) eq 0) then min_f = [ -180.0, -90.0 ]
		if (keyword_set (exact) and (size (max_f, /type) eq 0)) then max_f = min_f
	end
	x_pos = [ min (x_pos), max (x_pos) ]
	if (n_elements (max_d) ge 1) then if (max_d[0] lt 0) then x_pos = reverse (x_pos)
	dislin, 'gaxpar', x_pos[0], x_pos[1], extend[0], "x", xs, xe, xf, xd, xn
	if (n_elements (min_s) ge 1) then if (finite (min_s[0])) then xs = xs > min_s[0]
	if (n_elements (max_s) ge 1) then if (finite (max_s[0])) then xs = xs < max_s[0]
	if (n_elements (min_e) ge 1) then if (finite (min_e[0])) then xe = xe > min_e[0]
	if (n_elements (max_e) ge 1) then if (finite (max_e[0])) then xe = xe < max_e[0]
	x_pos = [ xs, xe ]
	dislin, 'gaxpar', x_pos[0], x_pos[1], "noextend", "x", xs, xe, xf, xd, xn
	if (n_elements (min_f) ge 1) then if (finite (min_f[0])) then xf = xf > min_f[0]
	if (n_elements (max_f) ge 1) then if (finite (max_f[0])) then xf = xf < max_f[0]
	if (n_elements (min_d) ge 1) then if (finite (min_d[0])) then xd = xd > min_d[0]
	if (n_elements (max_d) ge 1) then if (finite (max_d[0])) then xd = xd < max_d[0]
	if (n_elements (min_n) ge 1) then if (finite (min_n[0])) then xn = xn > min_n[0]
	if (n_elements (max_n) ge 1) then if (finite (max_n[0])) then xn = xn < max_n[0]
	dislin, 'labdig', round (xn), "x"

	if (n_elements (ticks) ge 2) then if (finite (ticks[1])) then dislin, 'ticks', round (ticks[1]), "y"
	if (strpos (log, 'y') ge 0) then y_pos = alog10 (y) else y_pos = double (y)
	y_pos = [ min (y_pos), max (y_pos) ]
	if (n_elements (max_d) ge 2) then if (max_d[1] lt 0) then y_pos = reverse (y_pos)
	dislin, 'gaxpar', y_pos[0], y_pos[1], extend[1], "y", ys, ye, yf, yd, yn
	if (n_elements (min_s) ge 2) then if (finite (min_s[1])) then ys = ys > min_s[1]
	if (n_elements (max_s) ge 2) then if (finite (max_s[1])) then ys = ys < max_s[1]
	if (n_elements (min_e) ge 2) then if (finite (min_e[1])) then ye = ye > min_e[1]
	if (n_elements (max_e) ge 2) then if (finite (max_e[1])) then ye = ye < max_e[1]
	y_pos = [ ys, ye ]
	dislin, 'gaxpar', y_pos[0], y_pos[1], "noextend", "y", ys, ye, yf, yd, yn
	if (n_elements (min_f) ge 2) then if (finite (min_f[1])) then yf = yf > min_f[1]
	if (n_elements (max_f) ge 2) then if (finite (max_f[1])) then yf = yf < max_f[1]
	if (n_elements (min_d) ge 2) then if (finite (min_d[1])) then yd = yd > min_d[1]
	if (n_elements (max_d) ge 2) then if (finite (max_d[1])) then yd = yd < max_d[1]
	if (n_elements (min_n) ge 2) then if (finite (min_n[1])) then yn = yn > min_n[1]
	if (n_elements (max_n) ge 2) then if (finite (max_n[1])) then yn = yn < max_n[1]
	dislin, 'labdig', round (yn), "y"

	if (n_elements (resolution) eq 2) then dislin, 'autres', round (resolution[0]), round (resolution[1])

	if (keyword_set (map)) then begin
		dislin, 'labels', "map", "xy"
	end else if (type ne '3D') then begin
		dislin, 'labtyp', default_label_type, default_label_axis
	end else begin
		dislin, 'labl3d', default_label_type
	end

	suffix = ''
	if (keyword_set (polar)) then begin
		suffix = 'p'
		dislin, 'grafp', xe, xf, xd, yf, yd
	end else if (n_elements (z) eq 0) then begin
		if (keyword_set (map)) then suffix = 'mp'
		dislin, 'graf'+suffix, xs, xe, xf, xd, ys, ye, yf, yd
	end else begin
		if (n_elements (ticks) ge 3) then if (finite (ticks[2])) then dislin, 'ticks', round (ticks[2]), "z"
		if (strpos (log, 'z') ge 0) then z_pos = alog10 (z) else z_pos = double (z)
		z_pos = [ min (z_pos), max (z_pos) ]
		if (n_elements (max_d) ge 3) then if (max_d[2] lt 0) then z_pos = reverse (z_pos)
		dislin, 'gaxpar', z_pos[0], z_pos[1], extend[2], "z", zs, ze, zf, zd, zn
		if (n_elements (min_s) ge 3) then if (finite (min_s[2])) then zs = zs > min_s[2]
		if (n_elements (max_s) ge 3) then if (finite (max_s[2])) then zs = zs < max_s[2]
		if (n_elements (min_e) ge 3) then if (finite (min_e[2])) then ze = ze > min_e[2]
		if (n_elements (max_e) ge 3) then if (finite (max_e[2])) then ze = ze < max_e[2]
		z_pos = [ zs, ze ]
		dislin, 'gaxpar', z_pos[0], z_pos[1], "noextend", "z", zs, ze, zf, zd, zn
		if (n_elements (min_f) ge 3) then if (finite (min_f[2])) then zf = zf > min_f[2]
		if (n_elements (max_f) ge 3) then if (finite (max_f[2])) then zf = zf < max_f[2]
		if (n_elements (min_d) ge 3) then if (finite (min_d[2])) then zd = zd > min_d[2]
		if (n_elements (max_d) ge 3) then if (finite (max_d[2])) then zd = zd < max_d[2]
		if (n_elements (min_n) ge 3) then if (finite (min_n[2])) then zn = zn > min_n[2]
		if (n_elements (max_n) ge 3) then if (finite (max_n[2])) then zn = zn < max_n[2]
		dislin, 'labdig', round (zn), "z"
		if (n_elements (num_colors) eq 1) then color_range = [ 1, num_colors ]
		if (n_elements (num_colors) ge 2) then color_range = minmax (num_colors)
		if (n_elements (color_range) eq 2) then dislin, 'colran', round (color_range[0]), round (color_range[1])
		suffix = '3'
		if (type eq '3D') then begin
			if (n_elements (view_point) eq 3) then begin
				if (size (view_type, /type) ne 7) then view_type = 'abs'
				dislin, 'view3d', double (view_point[0]), double (view_point[1]), double (view_point[2]), strupcase (strtrim (view_type, 2))
			end
			if (strcmp (clip, 'page', /fold_case)) then dislin, 'clip3d', "none"
			suffix = '3d'
		end
		dislin, 'graf'+suffix, xs, xe, xf, xd, ys, ye, yf, yd, zs, ze, zf, zd
	end
	if (draw_frame) then begin
		if (type eq '3D') then dislin, 'box3d' else dislin, 'box2d'
	end

	if (keyword_set (grid_lines)) then begin
		if (keyword_set (grid_color)) then dislin_color, grid_color
		if (suffix eq '3d') then begin
			dislin, 'grid3d', round (grid_lines[0]), round (grid_lines[1]), grid_type
		end else begin
			dislin, 'grid'+suffix, round (grid_lines[0]), round (grid_lines[1])
		end
		if (keyword_set (grid_color)) then dislin_color, 'fore'
	end

	if (size (light_mode, /type) ne 0) then begin
		on = where ((strtrim (light_mode, 2) ne '0') or strcmp (strtrim (light_mode, 2), 'on', /fold_case), complement=off, ncomplement=num_off, num)
		if (num le 0) then begin
			dislin, 'light', 'off'
		end else begin
			dislin, 'light', 'on'
			for pos = 0, num-1 do dislin, 'litmod', on[pos]+1, 'on'
			if (num_off ge 1) then begin
				for pos = 0, num_off-1 do dislin, 'litmod', off[pos]+1, 'off'
			end
		end
	end

	dislin_title

	dislin, 'clpbor', clip
end

