; IDL DISLIN wrapper shortcut procedure to start a new graph
; Version 1.6, 31.03.2017, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_next, reset=reset, initial=initial, text_font=text_font, text_size=text_size, tex_mode=tex_mode, tex_italics=tex_italics, hardware_font=hardware_font, nocheck=nocheck

	common dislin_page_config, default_text_font, default_text_size, default_tex_mode, default_tex_italics, default_hardware_font, default_output_format

	if (size (text_font, /type) ne 0) then default_text_font = text_font
	if (n_elements (text_size) eq 1) then default_text_size[1:2] = text_size
	if (n_elements (text_size) eq 2) then default_text_size = [ text_size, text_size[1] ]
	if (n_elements (text_size) eq 3) then default_text_size = text_size
	if (size (tex_mode, /type) ne 0) then default_tex_mode = tex_mode
	if (size (tex_italics, /type) ne 0) then begin
		if (size (tex_italics, /type) ne 7) then if (keyword_set (tex_italics)) then tex_italics = "on" else tex_italics = "off"
		default_tex_italics = tex_italics
	end
	if (size (hardware_font, /type) ne 0) then default_hardware_font = hardware_font

	if (not keyword_set (initial)) then dislin, 'endgrf'

	if (size (reset, /type) ne 0) then begin
		if ((size (reset, /type) ne 7) and keyword_set (reset)) then reset = 'all'
		if (size (reset, /type) eq 7) then begin
			num_resets = n_elements (reset)
			for pos = 0, num_resets-1 do begin
				dislin, 'reset', reset[pos]
			end
		end
		dislin_color, "black"
	end

	if ((size (nocheck, /type) eq 0) or (keyword_set (nocheck))) then dislin, 'errmod', "check", "off"
	if (keyword_set (default_hardware_font)) then dislin, 'hwfont'
	if (size (default_text_font, /type) eq 7) then begin
		builtin = [ 'disalf', 'simplx', 'duplx', 'triplx', 'complx', 'gothic', 'helve', 'helves', 'helvet', 'serif' ]
		if (total (strcmp (default_text_font[0], builtin, /fold_case)) ge 1) then begin
			for pos=0, n_elements (default_text_font)-1 do dislin, default_text_font[pos]
		end else begin
			if (size (default_output_format, /type) eq 7) then begin
				if (max (strcmp (default_output_format, ['ps','eps','pdf','svg'], /fold_case))) then dislin, 'psfont', default_text_font else dislin, 'simplx'
			end
		end
	end
	dislin, 'htitle', round (default_text_size[0])
	dislin, 'height', round (default_text_size[1])
	dislin, 'hname', round (default_text_size[2])

	dislin, 'chacod', "utf8"
	if (keyword_set (default_tex_mode)) then dislin, 'texmod', "on"
	dislin, 'texopt', default_tex_italics, 'italics'

	dislin_color
end

