; DISLIN: Demonstration of 3D BARS / IDL
; Version 1.4, 24.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_3d_bars

	xray  = [ 1., 3., 8., 1.5, 9., 6.3, 5.8, 2.3, 8.1, 3.5, 2.2, 8.7, 9.2, 4.8, 3.4, 6.9, 7.5, 3.8 ]
	yray  = [ 5., 8., 3.5, 2., 7., 1.,4.3, 7.2, 6.0, 8.5, 4.1, 5.0, 7.3, 2.8, 1.6, 8.9, 9.5, 3.2 ]
	z1ray = [ 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0., 0. ]
	z2ray = [ 4., 5., 3., 2., 3.5, 4.5, 2., 1.6, 3.8, 4.7, 2.1, 3.5, 1.9, 4.2, 4.9, 2.8, 3.6, 4.3 ]
	icray = [ 30, 30, 30, 30, 30, 30, 100, 100, 100, 100, 100, 100, 170, 170, 170, 170, 170, 170 ]

	xwray = replicate (0.5, n_elements (xray))
	ywray = xwray

	title = [ '', '', '3-D Bars / BARS3D' ]
	labels = [ 'X-axis', 'Y-axis', 'Z-axis' ]
	left = 200
	top = 800
	plot_size = [ 1800, 1800 ]

	dislin_page, 'xwin', page_format='da4p', /hardware_font
	dislin_axis, left, top, plot_size, type='3D', title=title, text_size=50, labels=labels, label_type='horizontal', label_axis='yz'
	dislin_graf, [0,10], [0,10], [0,5], grid_type='bottom', /exact, min_n=[1,1,1]
	dislin_bar, xray, yray, z1ray, z2ray, width=0.5, pattern=16, color=icray, label_color=255, label_type='second', label_position='outside'
	dislin_legend, [ 'First', 'Second', 'Third' ], pos=[ 1350, 1150 ]
	dislin_end

end

