; DISLIN: Demonstration of CURVE / IDL
; Version 1.4, 26.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_curve

	n = 101
	pi = !PI
	f = pi / 180.
	step = 360. / (n - 1)
	i = indgen (n)
	xray = i * step
	x = xray * f
	y1ray = sin (x)
	y2ray = cos (x)

	title = [ 'Demonstration of CURVE', '', 'SIN (X), COS (X)' ]
	labels = [ 'X-axis', 'Y-axis' ]
	left = 450
	top = 600
	plot_size = [ 2200, 1200 ]

	dislin_page, 'xwin', page_format='da4l', /hardware_font
	dislin_axis, left, top, plot_size, title=title, text_size=50, labels=labels, label_type='horizontal'
	dislin_graf, [0,360], [-1,1], /exact, ed=90, ticks=[9,10], background=0.95, grid_color=0.7
	dislin_curve, xray, y1ray, color='full_red'
	dislin_curve, xray, y2ray, color='full_green'
	dislin_end

end

