; DISLIN: Demonstration of FILE EXPORT of a SURFACE PLOT / IDL
; Version 1.4, 28.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_export_draw

	n = 50
	m = 50

	x = indgen (n) * 2.0 * !PI / (n - 1)
	y = indgen (m) * 2.0 * !PI / (m - 1)

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	title = [ '', 'Surface Plot of the Function', '', 'F(X,Y) = 2 * SIN(X) * SIN (Y)' ]
	labels = [ 'X-axis', 'Y-axis', 'Z-axis' ]
	left = 200
	top = 800
	plot_size = [ 1800, 1800 ]

	dislin_axis, left, top, plot_size, type='3D', title=title, text_size=50, labels=labels
	dislin_graf, [0,360], [0,360], [-3,3], /exact, ed=[90,90], en=[1,1,1], view_point=[-5,-5,4]
	dislin_plane, zmat, color='full_green', /surface
end


pro dislin_sample_highlevel_export

	; use virtual image in memory 
	dislin_page, 'virt', page_format='da4p', /hardware_font, file_mode='delete'
	dislin_sample_highlevel_export_draw
	; write PNG file
	dislin, 'rpng', 'sample_export.png'
	; write PNG data to a buffer
	dislin, 'rbfpng', cbuf, 0, return=n	; request size of PNG data
	dislin, 'rbfpng', cbuf, n		; copy image data to buffer
	; need to finish and re-open for exporting in different formats
	dislin_end
	print, "The PNG data has ", strlen (cbuf), " bytes."

	; write PS file
	dislin_page, 'ps', 'sample_export', page_format='da4p', /hardware_font, error_mode=['protocol','off']
	dislin_sample_highlevel_export_draw
	dislin_end

	; write EPS file
	dislin_page, 'eps', 'sample_export', page_format='da4p', /hardware_font, error_mode=['protocol','off']
	dislin_sample_highlevel_export_draw
	dislin_end

end

