; DISLIN: Demonstration of SHADED CONTOUR PLOT / IDL
; Version 1.4, 29.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_shaded_contour

	n = 50
	m = 50
	nlev = 12

	xray = indgen (n) * 1.6 / (n - 1)
	yray = indgen (m) * 1.6 / (m - 1)
	x = xray^2 - 1.
	y = yray^2 - 1.

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = x[i]^2 + y^2

	title = [ 'Shaded Contour Plot', '', 'F(X,Y) = (X[2$ - 1)[2$ + (Y[2$ - 1)[2$' ]
	labels = [ 'X-axis', 'Y-axis' ]
	left = 450
	top = 690
	plot_size = [ 1400, 1980 ]

	dislin_page, page_format='da4p', tex_mode=0, text_font=['complx','mixalf']
	dislin_axis, left, top, plot_size, title=title, text_size=50, labels=labels, label_type='horizontal'
	dislin_graf, [0,1.6], [0,1.6], /exact
	dislin_plane, zmat, xray, yray, zs=1.2, ze=0.1, contours=nlev, shade='poly'
	dislin_end

end

