; DISLIN: Demonstration of SPHERES AND TUBES / IDL
; Version 1.4, 29.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_spheres_tubes

	x = [ 10., 20., 10., 20., 5., 15., 25., 5., 15., 25., 5., 15., 25., 10., 20., 10., 20. ]
	y = [ 10., 10., 20., 20., 5., 5., 5., 15., 15., 15., 25., 25., 25., 10., 10., 20., 20. ]
	z = [ 5., 5., 5., 5., 15., 15., 15., 15., 15., 15., 15., 15., 15., 25., 25., 25., 25. ]
	idx = [ 1, 2, 1, 3, 3, 4, 2, 4, 5, 6, 6, 7, 8, 9, 9, 10, 11, 12, 12, 13,  5, 8, 8, 11, 6, 9, 9, 12, 7, 10, 10, 13,  14, 15, 16, 17, 14, 16, 15, 17, 1, 5, 2, 7, 3, 11, 4, 13, 5, 14, 7, 15, 11, 16, 13, 17 ]

	title = 'Spheres and Tubes'
	labels = [ 'X-axis', 'Y-axis', 'Z-axis' ]
	left = 0
	top = 400
	plot_size = [ 2100, 2100 ]

	dislin_page, page_format='da4p', /hardware_font
	dislin_axis, left, top, plot_size, type='3D', title=title, text_size=50, labels=labels, label_type='horizontal'
	dislin_graf, [0,30], [0,30], [0,30], /exact, /integer, /light

	dislin, 'zbfini', return=iret
	dislin, 'shdmod', 'smooth', 'surface'
	dislin, 'matop3', 1.0, 0.0, 0.0, 'diffuse'
	for i = 0, 16 do begin
		dislin, 'sphe3d', x[i], y[i], z[i], 2.0, 50, 25
	end

	dislin, 'matop3', 0.0, 1.0, 0.0, 'diffuse'
	for i = 0, 55, 2 do begin
		j1 = idx[i] - 1
		j2 = idx[i+1] - 1
		dislin, 'tube3d', x[j1], y[j1], z[j1], x[j2], y[j2], z[j2], 0.5, 5, 5 
	end
	dislin, 'zbffin'

	dislin_end

end

