; DISLIN: Demonstration of SURFACE CONTOUR PLOT / IDL
; Version 1.4, 29.02.2016, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_highlevel_surface_contour

	n = 50
	m = 50
	nlev = 20

	xray = indgen (n) * 360. / (n - 1)
	yray = indgen (m) * 360. / (m - 1)
	x = xray * !PI / 180.
	y = yray * !PI / 180.

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	title = [ '', 'Shaded Surface / Contour Plot', '', 'F(X,Y) = 2 * SIN(X) * SIN (Y)' ]
	labels = [ 'X-axis', 'Y-axis', 'Z-axis' ]
	left = 200
	top = 800
	plot_size = [ 1800, 1800 ]
	projection = [ [-1,-1,-1], [1,-1,-1], [1,1,-1] ]

	dislin_page, page_format='da4p', /hardware_font
	dislin_axis, left, top, plot_size, type='3D', title=title, text_size=50, labels=labels
	dislin_graf, [0,360], [0,360], [-2,2], /exact, ed=[90,90], en=[1,1,1]
	dislin_graf, [0,360], [0,360], /exact, ed=[90,90], en=[1,1], labeling='none', projection=projection
	dislin_plane, zmat, xray, yray, zs=-2, ze=1.8, contour=nlev, /shade
	dislin_graf, projection='end', /draw_frame
	dislin_plane, zmat, xray, yray, /surface, shade='smooth'
	dislin_end

end

