; DISLIN: Demonstration of CONTOUR PLOT / IDL
; Version 1.0, 24.07.2012, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_contour

	ctit1 = 'Contour Plot of the Function'
	ctit2 = 'F(X,Y) = 2 * SIN(X) * SIN (Y)'

	n = 50
	m = 50

	xray = indgen (n) * 360. / (n - 1)
	yray = indgen (m) * 360. / (m - 1)
	x = xray * !PI / 180.
	y = yray * !PI / 180.

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	dislin, 'scrmod', 'revers'
	dislin, 'metafl', 'cons'
	dislin, 'setpag', 'da4p'
	dislin, 'disini'
	dislin, 'pagera'
	dislin, 'complx'

	dislin, 'titlin', ctit1, 2
	dislin, 'titlin', ctit2, 4

	dislin, 'axspos', 450, 2670

	dislin, 'name', 'X-axis', 'X'
	dislin, 'name', 'Y-axis', 'Y'

	dislin, 'graf', 0., 360., 0., 90., 0., 360., 0., 90.

	dislin, 'height', 30
	for i = 0, 8 do begin
		zlev = -2. + i * 0.5
		if (i eq 4) then begin
			dislin, 'labels', 'NONE', 'CONTUR'
		end else begin
			dislin, 'labels', 'FLOAT', 'CONTUR'
		end
		dislin, 'setclr', (i+1) * 28
		dislin, 'contur', xray, n, yray, m, zmat, zlev
	end

	dislin, 'color', 'FORE'
	dislin, 'height', 50
	dislin, 'title'
	dislin, 'disfin'

end

