; DISLIN: Demonstration of FILE EXPORT of a SURFACE PLOT / IDL
; Version 1.0, 24.07.2012, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_export_draw

	ctit1 = 'Surface Plot of the Function'
	ctit2 = 'F(X,Y) = 2 * SIN(X) * SIN (Y)'

	n = 50
	m = 50

	x = indgen (n) * 2.0 * !PI / (n - 1)
	y = indgen (m) * 2.0 * !PI / (m - 1)

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	dislin, 'setpag', 'da4p'
	dislin, 'disini'
	dislin, 'pagera'
	dislin, 'complx'

	dislin, 'titlin', ctit1, 2
	dislin, 'titlin', ctit2, 4

	dislin, 'axspos', 200, 2600
	dislin, 'axslen', 1800, 1800

	dislin, 'name', 'X-axis', 'X'
	dislin, 'name', 'Y-axis', 'Y'
	dislin, 'name', 'Z-axis', 'Z'

	dislin, 'view3d', -5., -5., 4., 'ABS'
	dislin, 'graf3d', 0., 360., 0., 90., 0., 360., 0., 90., -3., 3., -3., 1.
	dislin, 'height', 50
	dislin, 'title'

	dislin, 'color', 'green'
	dislin, 'surmat', zmat, n, m, 1, 1
end


pro dislin_sample_export

	dislin, 'scrmod', 'revers'
	dislin, 'filmod', 'DELETE'		; overwrite existing file(s)

	; use virtual image in memory 
	dislin, 'metafl', 'virt'
	dislin_sample_export_draw

	; write PNG file
	dislin, 'rpng', 'sample_export.png'

	; write PNG data to a buffer
	dislin, 'rbfpng', cbuf, 0, return=n	; request size of PNG data
	dislin, 'rbfpng', cbuf, n		; copy image data to buffer

	; need to finish and re-open for exporting in different formats
	dislin, 'disfin'

	; write PS file
	dislin, 'metafl', 'PS'
	dislin, 'setfil', 'sample_export.ps'
	dislin_sample_export_draw
	dislin, 'errmod', 'PROTOCOL', 'OFF'
	dislin, 'disfin'

	; write EPS file
	dislin, 'metafl', 'EPS'
	dislin, 'setfil', 'sample_export.eps'
	dislin_sample_export_draw
	dislin, 'errmod', 'PROTOCOL', 'OFF'
	dislin, 'disfin'

	print, "The PNG data has ", strlen (cbuf), " bytes."
end

