; DISLIN: Demonstration of SHADED SURFACE PLOT / IDL
; Version 1.0, 24.07.2012, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_shaded_surface

	ctit1 = 'Shaded Surface Plot'
	ctit2 = 'F(X,Y) = 2 * SIN(X) * SIN (Y)'

	n = 50
	m = 50

	xray = indgen (n) * 360. / (n - 1)
	yray = indgen (m) * 360. / (m - 1)
	x = xray * !PI / 180.
	y = yray * !PI / 180.

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	dislin, 'scrmod', 'revers'
	dislin, 'metafl', 'cons'
	dislin, 'setpag', 'da4p'
	dislin, 'disini'
	dislin, 'pagera'
	dislin, 'complx'

	dislin, 'titlin', ctit1, 2
	dislin, 'titlin', ctit2, 4

	dislin, 'axspos', 200, 2600
	dislin, 'axslen', 1800, 1800

	dislin, 'name', 'X-axis', 'X'
	dislin, 'name', 'Y-axis', 'Y'
	dislin, 'name', 'Z-axis', 'Z'

	dislin, 'view3d', -5., -5., 4., 'ABS'
	dislin, 'graf3d', 0., 360., 0., 90., 0., 360., 0., 90., -3., 3., -3., 1.
	dislin, 'height', 50
	dislin, 'title'

	dislin, 'shdmod', 'smooth', 'surface'
	dislin, 'surshd', xray, n, yray, m, zmat
	dislin, 'disfin'

end

