; DISLIN: Demonstration of SURFACE PLOT / IDL
; Version 1.0, 24.07.2012, Philippe-A. Bourdin, Bourdin@MPS.mpg.de

pro dislin_sample_surface

	ctit1 = 'Surface Plot of the Function'
	ctit2 = 'F(X,Y) = 2 * SIN(X) * SIN (Y)'

	n = 50
	m = 50

	x = indgen (n) * 2.0 * !PI / (n - 1)
	y = indgen (m) * 2.0 * !PI / (m - 1)

	zmat = fltarr (n, m)
	for i = 0, n-1 do zmat[i,*] = 2 * sin(x[i]) * sin(y)

	dislin, 'scrmod', 'revers'
	dislin, 'metafl', 'cons'
	dislin, 'setpag', 'da4p'
	dislin, 'disini'
	dislin, 'pagera'
	dislin, 'complx'

	dislin, 'titlin', ctit1, 2
	dislin, 'titlin', ctit2, 4

	dislin, 'axspos', 200, 2600
	dislin, 'axslen', 1800, 1800

	dislin, 'name', 'X-axis', 'X'
	dislin, 'name', 'Y-axis', 'Y'
	dislin, 'name', 'Z-axis', 'Z'

	dislin, 'view3d', -5., -5., 4., 'ABS'
	dislin, 'graf3d', 0., 360., 0., 90., 0., 360., 0., 90., -3., 3., -3., 1.
	dislin, 'height', 50
	dislin, 'title'

	dislin, 'color', 'green'
	dislin, 'surmat', zmat, n, m, 1, 1
	dislin, 'disfin'

end

